summaryrefslogtreecommitdiffstats
path: root/libraries/openvdb
diff options
context:
space:
mode:
Diffstat (limited to 'libraries/openvdb')
-rw-r--r--libraries/openvdb/README16
-rw-r--r--libraries/openvdb/openvdb.SlackBuild128
-rw-r--r--libraries/openvdb/openvdb.info10
-rw-r--r--libraries/openvdb/slack-desc19
4 files changed, 173 insertions, 0 deletions
diff --git a/libraries/openvdb/README b/libraries/openvdb/README
new file mode 100644
index 0000000000..8e832e44fc
--- /dev/null
+++ b/libraries/openvdb/README
@@ -0,0 +1,16 @@
+OpenVDB is an Academy Award-winning open-source C++ library comprising
+a novel hierarchical data structure and a suite of tools for the
+efficient storage and manipulation of sparse volumetric data
+discretized on three-dimensional grids. It was developed by DreamWorks
+Animation for use in volumetric applications typically encountered in
+feature film production and is now maintained by the Academy Software
+Foundation (ASWF).
+
+OpenVDB can be compiled with Houdini (not on SBo), if someone needs
+support for it, feel free to modify the slackbuild to set
+
+-DOPENVDB_BUILD_HOUDINI_PLUGIN=ON
+
+VDB is a format for storing "volumetric data", such as fog, clouds,
+and "point cloud" in scientific data.
+
diff --git a/libraries/openvdb/openvdb.SlackBuild b/libraries/openvdb/openvdb.SlackBuild
new file mode 100644
index 0000000000..465bb243a4
--- /dev/null
+++ b/libraries/openvdb/openvdb.SlackBuild
@@ -0,0 +1,128 @@
+#!/bin/bash
+
+# Slackware build script for openvdb
+
+# Copyright 2023, Lockywolf
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=openvdb
+VERSION=${VERSION:-10.0.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DMAN_INSTALL_DIR=/usr/man \
+ -DOPENVDB_BUILD_AX=ON \
+ -DOPENVDB_BUILD_DOCS=ON \
+ -DOPENVDB_BUILD_MAYA_PLUGIN=OFF \
+ -DOPENVDB_BUILD_HOUDINI_PLUGIN=OFF \
+ -DOPENVDB_BUILD_NANOVDB=ON \
+ -DOPENVDB_BUILD_PYTHON_MODULE=ON \
+ -DOPENVDB_BUILD_VDB_AX=ON \
+ -DOPENVDB_BUILD_VDB_LOD=ON \
+ -DOPENVDB_BUILD_VDB_RENDER=ON \
+ -DOPENVDB_BUILD_VDB_TOOL=ON \
+ -DOPENVDB_BUILD_VDB_VIEW=ON \
+ -DOPENVDB_CORE_STATIC=OFF \
+ -DCMAKE_CXX_COMPILER_LAUNCHER=ccache \
+ -DUSE_PNG=ON \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+mv $PKG/usr/share/doc/* $PKG/usr/doc/$PRGNAM-$VERSION
+rm -rf $PKG/usr/share/doc
+
+cp -a \
+ CONTRIBUTING.md README.md LICENSE \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/openvdb/openvdb.info b/libraries/openvdb/openvdb.info
new file mode 100644
index 0000000000..88e5891ac6
--- /dev/null
+++ b/libraries/openvdb/openvdb.info
@@ -0,0 +1,10 @@
+PRGNAM="openvdb"
+VERSION="10.0.1"
+HOMEPAGE="https://github.com/AcademySoftwareFoundation/openvdb/"
+DOWNLOAD="UNSUPPORTED"
+MD5SUM=""
+DOWNLOAD_x86_64="https://github.com/AcademySoftwareFoundation/openvdb/archive/v10.0.1/openvdb-10.0.1.tar.gz"
+MD5SUM_x86_64="0239ff0c912a3eac76bd6a4ae1b03522"
+REQUIRES="c-blosc tbb glfw3"
+MAINTAINER="Lockywolf"
+EMAIL="for_sbo.openvdb_2023-07-12@lockywolf.net"
diff --git a/libraries/openvdb/slack-desc b/libraries/openvdb/slack-desc
new file mode 100644
index 0000000000..aca8c72974
--- /dev/null
+++ b/libraries/openvdb/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+openvdb: openvdb (a library for working with volumetric data forman VDB)
+openvdb:
+openvdb: OpenVDB is an Academy Award-winning open-source C++ library
+openvdb: comprising a novel hierarchical data structure and a suite of tools
+openvdb: for the efficient storage and manipulation of sparse volumetric data
+openvdb: discretized on three-dimensional grids. It was developed by
+openvdb: DreamWorks Animation for use in volumetric applications typically
+openvdb: encountered in feature film production and is now maintained by the
+openvdb: Academy Software Foundation (ASWF).
+openvdb:
+openvdb: